<?php
class AttendanceMasterConfController extends AppController
{
	var $helpers = array('Html', 'Javascript', 'Ajax','Pagination', 'Lv');
	var $components = array ('Pagination', 'Lv','Check','GenerateFiles');
	var $uses=array('Group', 'Host', 'Rlthstgrp','Grpauth', 'Authority','Rltuserauth','User','Configure','Validation',
	'Employee','Employeeaccount','Hsttime', 'Hstacc', 'Hstattendance', 'Workstatus','Employeeadacc', 'Oldaccount', 'Activedirectory','Oldhstaccount', 'Agentversion',
	'Grpattendconf', 'Hstactivelog');
	var $layout='attendance';
	function beforeFilter()
	{
		parent::beforeFilter();
		$this->pageTitle =__('title',$retrun=true); 
		if(isset($_POST['forHideVar'])){
			$this->set('forHideVar', $_POST['forHideVar']);
		}
		elseif(isset($_POST['forHideVar1'])){
			$this->set('forHideVar', $_POST['forHideVar1']);
		}
	}
	function index($errorMessage = null)
	{
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$this->set('glist',$glist);
		
		$status = $this->Workstatus->findAll(null,null,array("Workstatus.id"));
		$keys = Set::extract($status, '{n}.Workstatus.id');
		$vals = Set::extract($status, '{n}.Workstatus.name');
		$statuslist = array_combine($keys, $vals);
		$this->set('statuslist',$statuslist);
		
		if(!empty($errorMessage))
			$this->set('errorMessage',$errorMessage);
	}
	
	function lists($mode=null)
	{
		$this->layout="ajax";
	
		$group_id = $this->data['Employee']['group_id'];
		$keyword = $this->data['Employee']['keyword'];
		$host_name = $this->data['Host']['host_name'];
		$status = $this->data['Employee']['status'];
		$version = $this->data['Agentversion']['version'];
		
		$wstatus = $this->data['Workstatus']['id'];
		$serr = $this->data['Workstatus']['err'];

		///取得条件設定
		$asso = array(
			'Group : groups : LEFT' => array('Employee.group_id = Group.id'),
			'Employeeaccount : employeeaccounts : LEFT' => array(
				'Employeeaccount.employee_id = Employee.id',
				'Employeeaccount.number=0'),
			'Host : hosts : LEFT' => array('Host.id = Employeeaccount.host_id'),
			'Agentversion : agentversions : LEFT' => array('Host.id = Agentversion.host_id'),
			'Hstattendance : hstattendance : LEFT' => array('Host.id = Hstattendance.host_id'),
			'Workstatus : workstatus : LEFT' => array('Workstatus.id = Hstattendance.status'),
			'Grpattendconf : grpattendconf : LEFT' => array('1 = 1'),
			'Hstacc : hstaccs : LEFT' => array(
				'Employeeaccount.account = Hstacc.account',
				"Hstacc.account != ''",				
				'Employeeaccount.host_id = Hstacc.host_id'),
			'Employeeadacc : employeeadaccs : LEFT' => array('Employeeadacc.employee_id = Employee.id'),
			'Hstacc2 : hstaccs : left' => array(
				"Employeeadacc.account like concat(Hstacc2.domain,'%\\\',Hstacc2.account)",
				'Host.id = Hstacc2.host_id'),
			'A : (select host_id, max(case when log_status = 1 then lasttime end) as login, max(case when log_status = 2 then lasttime end) as logout from hstactivelogs group by host_id) : left' => array(
				"A.host_id = Host.id"),
		) ;
		
		//取得項目
		$fields = array(
		'Employee.id',
		'Employee.id_name',
		'Employee.name',
		'Employee.enabled',
		'Employee.status',
		'Employee.name_eng',
		'Employee.linenumber',
		'Group.group_name',
		'Agentversion.version',
		'Workstatus.name',
		'Host.host_name',
		'Employeeaccount.account',
		'Employeeaccount.exist',
		'Employeeadacc.account',
		'(case when Employeeadacc.account is null or Employeeadacc.account = "" then Employeeaccount.account else Employeeadacc.account end) as Account__name',
		'sum(Hstacc2.account is not null) as Employeeadacc__exist',
		'(case when Hstattendance.status != 2 and TIMESTAMPDIFF(SECOND, Hstattendance.heartbeat, now()) > Grpattendconf.heartbeat then Workstatus.id + 100000 
		when Hstattendance.status = 2 and A.login > A.logout then Workstatus.id + 200000 
		else Workstatus.id end) as Hstattendance__disconnect',
		);
		
		//$criteria[] = "Employeeaccount.number=0";
		$criteria[] = "3=3";
		//グループの指定
		if($group_id != 1 && isset($group_id)){
			$group_ids = "";
			$glist = $this->Grpauth->getChildrenByParent($group_id);
			foreach($glist as $key => $g){
				$group_ids .= $key.",";
			}
			$group_ids = rtrim($group_ids, ","); 
			$criteria[]="Employee.group_id in (".$group_ids.")";
		}
		//キーワードを指定
		if($keyword != ""){
			$kw = $this->Lv->spec_char_like($keyword);
			$criteria[]="(Employee.id_name like '%".$kw."%' or Employee.name like '%".$kw."%' or Employee.name_eng like '%".$kw."%' or Employee.linenumber like '%".$kw."%' )";
		}
		if($host_name != ""){
			$kw = $this->Lv->spec_char_like($host_name);
			$criteria[]="Host.host_name like '%".$kw."%'";
		}
		if($status != ""){
			$criteria[]="Employee.status = ".$status;
		}
		if($version != ""){
			$kw = $this->Lv->spec_char_like($version);
			$criteria[]="Agentversion.version like '".$kw."%'";
		}
		if($wstatus != ""){
			$criteria[]="Workstatus.id = ".$wstatus;
		}
		if($serr != "0")
			$criteria['GROUP BY']="Employee.id HAVING Hstattendance__disconnect > 100000";
		else
			$criteria['GROUP BY']="Employee.id";
		
		
		//取得
		$this->Pagination->show = 50;
		list($order,$limit,$page) = $this->Pagination->init($criteria, null, 
						array('ajaxDivUpdate'=>'lists', 'url'=>'/attendance_master_conf/lists', 'modelClass'=>'Employee', 'queryType' => array('function' => 'findByAsso', 'asso' => $asso), 'sortBy' => $this->Lv->sortBy(
				'Employee.id_name',
				'Employee.name',
				'Employee.name_eng',
				'Group.group_name',
				'Employee.linenumber',
				'Host.host_name',
				'Account.name',
				'Employee.status',
				'Agentversion.version',
				'Hstattendance.disconnect')));
		if($mode == "csv"){
			$Employees = $this->Employee->findByAsso($criteria, $fields, $order, null, null, $asso);
			
			foreach($Employees as &$record){
			
				if($record['Employee']['status'] == '1')
					$record['Employee']['statusstr'] = __('enabled', $return = true);
				else if($record['Employee']['status'] == '2')
					$record['Employee']['statusstr'] = __('resigned', $return = true);
				else 
					$record['Employee']['statusstr'] = __('disabled', $return = true);
			}
			
			$this->csvdown($Employees);exit();
			
		}else{
			$Employees = $this->Employee->findByAsso($criteria, $fields, $order, $limit, $page, $asso);
			$this->set('data',$Employees);
			//debug($Employees);
			$this->render('lists');
		}
		
	}
	
	function csvdown($data = array())
	{
		require_once( 'csv/DlFactory.php' );
		$csv = DlFactory::create("attendance_masters");
		$csv->sendCSVFile($data,$this->data, __('csv_name',$return = true));
		exit;
	}
	
	function update($eid = null)
	{
		//$this->layout='ajax';
		$criteria = array();
		
		$group_id = $this->_getUserGroup();
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$this->set('glist',$glist);
		
		$hostlist = $this->Rlthstgrp->getHostsByGroup($group_id);
		//他に登録されているホストをリスト化
		$host_ids = "";
		foreach($hostlist as $key => $h){
			$host_ids .= $key.",";
		}
		$host_ids = rtrim($host_ids, ",");
		$fields = array('Employeeaccount.host_id');
		$criteria[]="Employeeaccount.host_id in (".$host_ids.")";
		if(is_numeric($eid))
			$criteria[]="Employeeaccount.employee_id != ".$eid;
		$hlist = $this->Employeeaccount->findAll($criteria, $fields, null, null, 1);
		$this->set('registred',$hlist);
		//var_dump($hlist);
		
		$hostlist = array("-1"=>" ") + $hostlist;
		$this->set('hostlist',$hostlist);
		

		$criteria = array();
		if(is_numeric($eid)){//編集
			$this->set('edit', true);
			//取得条件設定
			$asso = array(
				'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
				'Host : hosts : LEFT' => array('Host.id = Employeeaccount.host_id'),
				'Employeeadacc : employeeadaccs : LEFT' => array('Employeeadacc.employee_id = Employee.id'),
			) ;
			
			//取得項目
			$fields = array(
			'Employee.id',
			'Employee.id_name',
			'Employee.name',
			'Employee.name_eng',
			'Employee.linenumber',
			'Employee.group_id',
			'Employee.enabled',
			'Employee.status',
			'Host.id',
			'Host.host_name',
			'Employeeaccount.account',
			'Employeeaccount.number',
			'Employeeadacc.account',
			);
			
			$criteria[]="Employee.id = ".$eid;
			$Employee = $this->Employee->findByAsso($criteria, $fields, 'Employeeaccount.number', null, null, $asso);
			//debug($Employee);
			
			$this->set('curtID', $Employee[0]['Employee']['id']);
			$this->set('curtIDName', $Employee[0]['Employee']['id_name']);
			$this->set('curtName', $Employee[0]['Employee']['name']);
			$this->set('curtNameeng', $Employee[0]['Employee']['name_eng']);
			$this->set('curtGroup', $Employee[0]['Employee']['group_id']);
			$this->set('curtLine', $Employee[0]['Employee']['linenumber']);
			//$this->set('curtEnabled', $Employee[0]['Employee']['enabled']);
			$this->set('curtStatus', $Employee[0]['Employee']['status']);
			$this->set('curtDomain', $Employee[0]['Employeeadacc']['account']);
			
			$curtHosts = array();
			$curtAccounts = array();
			$acclists = array();
			foreach($Employee as $key => $e){
				$curtHosts[$key] = $e['Host']['id'];
				$curtAccounts[$key] = $e['Employeeaccount']['account'];
				
				$accounts = $this->Hstacc->findAll(array('host_id' => $e['Host']['id']));
				$acclist = array('' => __('select_account', true));
				foreach($accounts as $acc){
					if(!empty($acc['Hstacc']['account']))
						$acclist[$acc['Hstacc']['account']] = $acc['Hstacc']['account'];
				}
				$acclists[$key] = $acclist;
			}
			$this->set('acclists', $acclists);
			$this->set('curtHosts', $curtHosts);
			$this->set('curtAccounts', $curtAccounts);

			if(empty($Employee[0]['Employeeadacc']['account']))
				$this->set('curtAccount', $Employee[0]['Employeeaccount']['account']);
			else
				$this->set('curtAccount', $Employee[0]['Employeeadacc']['account']);
			$this->set('curtHost', $Employee[0]['Host']['id']);
			$this->set('curtHostName', $Employee[0]['Host']['host_name']);
		}else{//追加
			$this->set('edit', false);
			$this->set('curtStatus', 1);
		}
		//$this->render('form');
	}
	
	function form($eid = null)
	{
		$this->layout='ajax';
		$criteria = array();
		
		$group_id = $this->_getUserGroup();
		
		$glist = $this->Grpauth->getChildrenByParent($group_id);
		$this->set('glist',$glist);
		
		$hostlist = $this->Rlthstgrp->getHostsByGroup($group_id);
		//他に登録されているホストをリスト化
		$host_ids = "";
		foreach($hostlist as $key => $h){
			$host_ids .= $key.",";
		}
		$host_ids = rtrim($host_ids, ",");
		$fields = array('Employeeaccount.host_id');
		$criteria[]="Employeeaccount.host_id in (".$host_ids.")";
		if(is_numeric($eid))
			$criteria[]="Employeeaccount.employee_id != ".$eid;
		$hlist = $this->Employeeaccount->findAll($criteria, $fields, null, null, 1);
		$this->set('registred',$hlist);
		//var_dump($hlist);
		
		$hostlist = array("-1"=>" ") + $hostlist;
		$this->set('hostlist',$hostlist);
		

		$criteria = array();
		if(is_numeric($eid)){//編集
			$this->set('edit', true);
			//取得条件設定
			$asso = array(
				'Employeeaccount : employeeaccounts : LEFT' => array('Employeeaccount.employee_id = Employee.id'),
				'Host : hosts : LEFT' => array('Host.id = Employeeaccount.host_id'),
				'Employeeadacc : employeeadaccs : LEFT' => array('Employeeadacc.employee_id = Employee.id'),
			) ;
			
			//取得項目
			$fields = array(
			'Employee.id',
			'Employee.id_name',
			'Employee.name',
			'Employee.group_id',
			'Employee.enabled',
			'Host.id',
			'Employeeaccount.account',
			'Employeeaccount.number',
			'Employeeadacc.account'
			);
			
			$criteria[]="Employee.id = ".$eid;
			$Employee = $this->Employee->findByAsso($criteria, $fields, 'Employeeaccount.number', null, null, $asso);
			//debug($Employee);
			
			$this->set('curtID', $Employee[0]['Employee']['id']);
			$this->set('curtIDName', $Employee[0]['Employee']['id_name']);
			$this->set('curtName', $Employee[0]['Employee']['name']);
			$this->set('curtGroup', $Employee[0]['Employee']['group_id']);
			//$this->set('curtEnabled', $Employee[0]['Employee']['enabled']);
			$this->set('curtStatus', $Employee[0]['Employee']['status']);
			$this->set('curtDomain', $Employee[0]['Employeeadacc']['account']);
			
			$curtHosts = array();
			$curtAccounts = array();
			$acclists = array();
			foreach($Employee as $key => $e){
				$curtHosts[$key] = $e['Host']['id'];
				$curtAccounts[$key] = $e['Employeeaccount']['account'];
				
				$accounts = $this->Hstacc->findAll(array('host_id' => $e['Host']['id']));
				$acclist = array('' => __('select_account', true));
				foreach($accounts as $acc){
					if(!empty($acc['Hstacc']['account']))
						$acclist[$acc['Hstacc']['account']] = $acc['Hstacc']['account'];
				}
				$acclists[$key] = $acclist;
			}
			$this->set('acclists', $acclists);
			$this->set('curtHosts', $curtHosts);
			$this->set('curtAccounts', $curtAccounts);

			
		}else{//追加
			$this->set('edit', false);
		
		}
		//$this->render('form');
	}
	
	function del(){
		$this->layout = 'ajax';
		//	debug($this->data['Employee']['delid']);
		if(isset($this->data['Employee']['delid'])){
			$eids  = $this->data['Employee']['delid'];
			foreach ($eids as $i => $check){
				$crit = array('employee_id ='.$check);
				$ad = $this->Employeeadacc->find($crit);
				if(!empty($ad)){
					$old = $ad['Employeeadacc']['account'];
					//以前のアカウントを記録して設定を無効化する
					$olddomain = array(
						'Oldaccount' => array(
								'account' => $this->Lv->spec_char_dbm($old),
							)
						); 						
					$this->Oldaccount->save($olddomain);
				}
				
				//削除したアカウントを記録
				$accs = $this->Employeeaccount->findAll($crit);
				if(!empty($accs)){
					foreach($accs as $acc){
						$hid = $acc['Employeeaccount']['host_id'];
						$ac = $acc['Employeeaccount']['account'];
						$this->Oldhstaccount->save(array(
									'Oldhstaccount' => array('host_id' => $hid, 'account' => $ac, 'hide' => 1, 'deleted' => 0)
								));
					}
				}
				$this->Employee->del($check);
				$this->Employeeaccount->deleteAll(array("employee_id =". $check));
				$this->Employeeadacc->deleteAll(array("employee_id =". $check));
			}
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount'), 1);
		}
		$this->lists();
	}
	function activate($e = 1){
		$this->layout = 'ajax';
		
		$glist = $this->Grpauth->getChildrenByParent($this->_getUserGroup());
		$group_ids = "";
		foreach($glist as $key => $g){
			$group_ids .= $key.",";
		}
		$group_ids = rtrim($group_ids, ","); 
		
		$enabled = 0;
		$status = 0;
		if($e == 0){
			$enabled = 0;
			$status = 0;
		}else{
			$enabled = 1;
			$status = 1;
		}
		
		//	debug($this->data['Employee']['delid']);
		if(isset($this->data['Employee']['delid'])){
			$eids  = $this->data['Employee']['delid'];
			//var_dump($eids);
			foreach ($eids as $i => $check){					
				$this->Employee->updateAll(
					array('Employee.id = '.$check, 
						'Employee.group_id in ('.$group_ids.')'), 
					array('Employee.enabled' => $enabled, 'Employee.status' => $status) );
			}
			$this->GenerateFiles->hook_by_ps(0, array('hostaccount'), 1);
		}
		$this->lists();
	}
	function reset(){
		$this->layout = 'ajax';
		//	debug($this->data['Employee']['delid']);
		if(isset($this->data['Employee']['delid'])){
			$eids  = $this->data['Employee']['delid'];
			foreach ($eids as $i => $check){
				$crit = array('employee_id ='.$check);

				//PC状態をログオフに
				$accs = $this->Employeeaccount->findAll($crit);
				if(!empty($accs)){
					foreach($accs as $acc){
						$hid = $acc['Employeeaccount']['host_id'];
						
						$this->Hstattendance->save(array(
									'Hstattendance' => array('host_id' => $hid, 'status' => 2)
								));
					}
				}
			}
		}
		$this->lists();
	}
	
	function add($rand)
	{//debug($this->data);
		$this->layout = 'ajax';
		$errorMessage = array();
		
		$id = $this->data['Employee']['id'];
		$id_name = $this->Lv->spec_char_dbm($this->data['Employee']['id_name']);
		$name = $this->Lv->spec_char_dbm($this->data['Employee']['name']);
		$name_eng = $this->Lv->spec_char_dbm($this->data['Employee']['name_eng']);
		$linenumber = $this->Lv->spec_char_dbm($this->data['Employee']['linenumber']);
		
		$group_id = $this->data['Employee']['group_id'];
		$host_id = $this->data['host_id'][0];
		$account = $this->data['account'][0];
		
		$reset = false;
		if(!is_null($this->data['Hstattendance']['reset']) && $this->data['Hstattendance']['reset'] == 1)
			$reset = true;

		//$enabled = $this->data['Employee']['enabled'];
		$status = $this->data['Employee']['status'];

		$errorMessage = $this->addEmployee($id, $id_name, $name, $name_eng, $group_id, $linenumber, $host_id, $account, $status, false, true);

		$this->set('errorMessage', $errorMessage);
		
		if(empty($errorMessage) && $reset)
		{
			$this->Hstattendance->save(array(
					'Hstattendance' => array('host_id' => $host_id, 'status' => 2)
				));
		}
	}
	function addEmployee($id, $id_name, $name, $name_eng, $group_id, $linenumber, $host_id, $account, $status, $check_domain = true, $savefile = true)
	{//$id:新規の時nullか""
		$edit = false;
		$errorMessage = array();
		//echo $id;
		//debug($this->data);
			
		//形式確認
		$isdomain = true;
		$pos = strpos($account, "\\");
		if($pos === false)
		{
			$isdomain = false;
		}
			
		
		if(empty($id_name)){
			$errorMessage['employee_id'][] = 'E-00100';
		}else if(empty($id)){//社員IDの重複
			$criteria = array();
			$criteria[] = "Employee.id_name = '".$this->Lv->spec_char_dbm($id_name)."'";
			$acc = array();
			$acc = $this->Employee->find($criteria);
			if(!empty($acc)){
				$errorMessage[$id_name][] = 'E-01900';
			}
		}
		if(empty($name)){
			$errorMessage['name'][] = 'E-00100';
		}
		
		if($host_id == -1)
			$errorMessage['computer_name'][] = 'E-00100';
		
		$regex = '/[\/\[\]:;|=,+*?<>@"]/';
		if (preg_match($regex, $account)) {
			$errorMessage['account_name'][] = 'E-00800';
		}
		if(empty($account)){
			$errorMessage['account_name'][] = 'E-00100';
		}
		
		//他の社員を確認
/*		for ($num = 0; $num < 1; $num++){
		if(!$isdomain){
			if(empty($host_id))
				continue;
			if($host_id == -1)
				continue;
			//同じPC+アカウントが設定されていないか
			$criteria = array();
			$criteria[] = "Employeeaccount.host_id =". $host_id;
			$criteria[] = "Employeeaccount.account = '".$this->Lv->spec_char_dbm($account)."'";
			if(!empty($id)){//編集の場合
				$criteria[] = "Employeeaccount.employee_id !=".$id;
			}	
			$acc = array();
			$acc = $this->Employeeaccount->find($criteria);
			if(!empty($acc)){
				$host = array();
				$host = $this->Host->find("Host.id=".$host_id);
				$errorMessage[$host['Host']['host_name']][] = 'UPE-00200';
			}
			//他のグループで同じPCが設定されていないか
			$criteria = array();
			$criteria[] = "Employee.group_id !=".$group_id;
			$criteria[] = "Employeeaccount.host_id =". $host_id;
			if(!empty($id)){//編集の場合
				$criteria[] = "Employeeaccount.employee_id !=".$id;
			}	
			$asso = array('Employee : employees' => array('Employee.id = Employeeaccount.employee_id'));
			$fld = array("Employeeaccount.account");
			$acc2 = array();
			$acc2 = $this->Employeeaccount->findByAsso($criteria, $fld, null,null,null, $asso);
			if(!empty($acc2)){
				$host = $this->Host->find("Host.id=".$host_id);
				$errorMessage[$host['Host']['host_name']][] = 'UPE-00210';
			}
		}else{//ドメインアカウントの重複
			$criteria = array();
			if(!empty($id)){//編集の場合
				$criteria[] = "Employeeadacc.employee_id != ".$id;
			}
			$criteria[] = "Employeeadacc.account = '".$this->Lv->spec_char_dbm($account)."'";
			$acc = array();
			$acc = $this->Employeeadacc->find($criteria);
			if(!empty($acc)){
				$errorMessage[$domain][] = 'E-01900';
			}
			if($check_domain){
				$check = $this->_checkAccount(array(substr($domain, $pos+1)), $cmdresult);
				if($check == 0){
					$cmdrs = explode(',', $cmdresult);
					//var_dump($cmdrs);
					if($cmdrs[0] != 0)
						$errorMessage[$domain][] = 'UPE-00150';
				}
			}
		}
		}
*/		
		if(empty($errorMessage)){
			$user = $this->Session->read('user');
			if($status == 2)
				$enabled = 0;
			else
				$enabled = $status;
			$upddate = date("Y/m/d H:i:s");
			$newEmployee = array();
			$newEmployee = array(
				'Employee' => array(
						'id_name' => $this->Lv->spec_char_dbm($id_name),
						'name' => $this->Lv->spec_char_dbm($name),
						'group_id' => $group_id,
						'status' => $status,
						'enabled' => $enabled,
						'name_eng' => $this->Lv->spec_char_dbm($name_eng),
						'linenumber' => $this->Lv->spec_char_dbm($linenumber),
						'update_time' => "'".$upddate."'",
						'update_user' => "'".$user['user_name']."'"
					)
				); 		
//var_dump($id);			echo empty($id) ? "empty" : "notempty";
			if(!empty($id)){//編集の場合
				$edit = true;
				$newEmployee['Employee']['id'] = $id;
			}else{
				$newEmployee['Employee']['id'] = null;
				$newEmployee['Employee']['regist_user'] = "'".$user['user_name']."'";
			}
			$this->Employee->save($newEmployee);
			
			//$newid = $this->Employee->getLastInsertID();
			$newid = null;
			if(!empty($id)){//編集の場合
				$newid = $id;
			}else{
				$cr = array("id_name = '".$this->Lv->spec_char_dbm($id_name)."'",
						"update_time = '".$upddate."'");
				$tmp = array();
				$tmp = $this->Employee->find($cr);
				$newid = $tmp['Employee']['id'];	
			}
				
			for ($num = 0; $num < 1; $num++){
				if(empty($host_id))
					continue;
				if($host_id == -1)
					continue;
				$newAccount = array();
				if($isdomain)
					$account_tmp = '';
				else
					$account_tmp = $this->Lv->spec_char_dbm($account);
					
				
				$newAccount = array(
							'Employeeaccount' => array(
								'number' => 0,
								'employee_id' => $newid,
								'host_id' => $host_id,
								'account' => $account_tmp,
								'exist' => 2
							)
						); 
				
				
				if($edit){//編集の場合
					//debug($newAccount);	
					$crit = array('employee_id ='.$newid, 'number = 0');
					$acc = array();
					$acc = $this->Employeeaccount->find($crit);
					if($host_id == -1){//ホストで空白を選択
						if(!empty($acc)){//以前のアカウントがあれば設定を削除
							$hid = $acc['Employeeaccount']['host_id'];
							$ac = $this->Lv->spec_char_dbm($acc['Employeeaccount']['account']);
							$this->Hsttime->deleteAll(array('host_id ='.$hid,"account ='".$ac."'"));
							
							$crit2 = array('host_id ='.$hid, "account ='".$ac."'");
							$this->Oldhstaccount->deleteAll($crit2);
							$this->Oldhstaccount->save(array(
									'Oldhstaccount' => array('host_id' => $hid, 'account' => $ac, 'hide' => 1, 'deleted' => 0)
								));
						}
						$this->Employeeaccount->deleteAll($crit);
						continue;
					}

					if(!empty($acc)){
						$exist = $acc['Employeeaccount']['exist'];
						//アカウント名orホスト名が変わったら稼働時間設定を削除
						if($acc['Employeeaccount']['account'] != $account_tmp || $acc['Employeeaccount']['host_id'] != $host_id){
							$hid = $acc['Employeeaccount']['host_id'];
							$ac = $this->Lv->spec_char_dbm($acc['Employeeaccount']['account']);
							$this->Hsttime->deleteAll(array('host_id ='.$hid,"account ='".$ac."'"));
							
							$crit2 = array('host_id ='.$hid, "account ='".$ac."'");
							$this->Oldhstaccount->deleteAll($crit2);
							$this->Oldhstaccount->save(array(
									'Oldhstaccount' => array('host_id' => $hid, 'account' => $ac, 'hide' => 1, 'deleted' => 0)
								));
							$exist = 2;//アカウント存在不明
						}
						$query = "update employeeaccounts set host_id={$host_id}, account='$account_tmp', exist={$exist} where employee_id ={$newid} and number =0";
						$this->Employeeaccount->execute($query);
					}else{//前の設定は無い
						$this->Employeeaccount->save($newAccount);
					}
				}else if($host_id != -1){
					//debug($newAccount);				
					$this->Employeeaccount->save($newAccount);
				}
			}
			
			//登録しようとするアカウントを削除対象から除外
			if(!$isdomain){
				if(!empty($host_id))
				if($host_id != -1)//ホストで空白を選択
				{
					$crit2 = array('host_id ='.$host_id, "account ='".$this->Lv->spec_char_dbm($account)."'");
					$this->Oldhstaccount->deleteAll($crit2);
				}
			}
			
			
			//ドメインアカウント
			$crit = array('employee_id ='.$newid);
			$ad = $this->Employeeadacc->find($crit);
			if(!empty($ad)){
				$old = $ad['Employeeadacc']['account'];
				if($old != $domain){//以前のアカウントを記録して設定を無効化する
					$olddomain = array(
					'Oldaccount' => array(
							'account' => $this->Lv->spec_char_dbm($old),
						)
					); 						
					$this->Oldaccount->save($olddomain);
				}
				$this->Employeeadacc->deleteAll($crit);
			}
			if($isdomain){
				if(!empty($account)){
					//無効化対象から削除
					$crit = array("account ='".$this->Lv->spec_char_dbm($account)."'", 'host_id = 0');
					$this->Oldaccount->deleteAll($crit);
					
					$newEmployeead = array(
						'Employeeadacc' => array(
								'employee_id' => $newid,
								'number' => 0,
								'account' => $this->Lv->spec_char_dbm($account),
							)
						); 						
					$this->Employeeadacc->save($newEmployeead);
				}
			}
			if($savefile)
				$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount','uptime'), 1);
		}
		return $errorMessage;
	}
	
	function do_import()
  	{
  		require_once("csv_imports_controller.php");
  		$hear_num = 1;
		//$dataにCSVからの情報が入る
		$data = array();
		$data = CsvImportsController :: do_import($hear_num);
		//debug($data);
		
		$errorMessage = array();
		if($data[0]!='error_csv' && $data[0]!='error_format'){
			//$errorMessage=$this->search(1,$data);
			/*foreach($data as $e){

			}*/
			empty($errorMessage)?$errorMessage=null:$errorMessage=$errorMessage;
		}else{
			$errorMessage[__('surecsv',$return = true)][] = 'E-06000';
		}
		
		if(empty($errorMessage)){
			$domains = array();
			$orgdomains = array();
			$linenum = 1;
			foreach($data as $v)
			{
				$linenum++;
				if (is_array($v)) 
				{
					$err = array();
					//社員ID(既にあれば変更)
					$id = null;
					$id_name = $this->Lv->spec_char_dbm($v[0]);
					$emp = array();
					$emp = $this->Employee->findByIdName($id_name);
					if(!empty($emp))
						$id = $emp['Employee']['id'];

					//氏名
					$name = $v[1];
					//氏名
					$name_eng = $v[2];
					//グループ
					$group = $this->Group->findByGroupName($this->Lv->spec_char_dbm($v[3]));
					if(empty($group))
						$err[$v[3]][] = 'UPE-00400';//存在しない
					$group_id = $group['Group']['id'];
					//内線番号
					$linenumber = $v[4];
					//コンピュータ名
					if(!empty($v[5])){
						$host = array();
						$host = $this->Host->findByHostName($this->Lv->spec_char_dbm($v[5]));
						if(empty($host))
							$err[$v[5]][] = 'UPE-00300';//無い
						else
							$host_id = $host['Host']['id'];
					}else
						$host_id = -1;//削除
		
					//アカウント名
					$account = $this->Lv->spec_char_dbm($v[6]);
					
					//有効化
					if(!empty($v[7]) && ( $v[7] == __('enabled', true) || $v[7] == 0))
						$status = 1;
					else if(!empty($v[7]) && ( $v[7] == __('disabled', true) || $v[7] == 1))
						$status = 1;
					else if(!empty($v[7]) && ( $v[7] == __('resigned', true) || $v[7] == 2))
						$status = 2;
					else
						$status = 0;
					$msg = array();
					if(empty($err)){//エラーがある行は入れない
						//$msg['sss'][] = "_".$id."/".$id_name."/".$name."/".$name_eng."/".$group_id."/".$linenumber."/".$host_id."/".$account."/".$status;
						$msg = $this->addEmployee($id, $id_name, $name, $name_eng, $group_id, $linenumber, $host_id, $account, $status, false, false);
						if(!empty($msg))
							$errorMessage[$linenum] = $msg;
					}else
						$errorMessage[$linenum] = $err;
				}
			}
			$this->GenerateFiles->hook_by_ps(0, array('uptimeaccount','hostaccount','uptime'), 1);

		}

		$this->index($errorMessage,null);
		$this->layout='attendance';
		$this->render("index");
  	}
	
	function getAccounts()
	{
		$this->layout = 'ajax';
		$acclist = array('' => __('select_account', true));
		if(!empty($this->data['host_id']))
		{
			foreach($this->data['host_id'] as $id => $host){
				$host_id = $host;
				$index = $id;
			}
			if($host_id > -1){
				//ホストのアカウントを取得
				$accounts = $this->Hstacc->findAll(array('host_id' => $host_id));
				foreach($accounts as $acc){
					if(!empty($acc['Hstacc']['account']))
						$acclist[$acc['Hstacc']['account']] = $acc['Hstacc']['account'];
				}
				$this->set('index', $index);
				$this->set('host_id', $host_id);
			}
		}
		$this->set('acclist', $acclist);
		$this->render("select");
	}

	function set_str_encoding($name)
    {
        $result= mb_convert_encoding($name,__('CharacterSet',$retrun=true),"UTF-8"); 
        return $result;
    } 
	
	function hostsearch()
	{
		$this->layout = 'ajax';
		$name = $this->data['Search']['name'];
		$group_id = $this->data['Search']['group'];
		
		
		$crit = array("1=1");
		if(!empty($name))
			$crit[] = "Host.host_name like '%".$this->Lv->spec_char_like($name)."%'";
		//if(!empty($group))
		//	$crit[] = "Employee.group_id = ".$group;
		if($group_id != 1 && isset($group_id)){
			$group_ids = "";
			$glist = $this->Grpauth->getChildrenByParent($group_id);
			foreach($glist as $key => $g){
				$group_ids .= $key.",";
			}
			$group_ids = rtrim($group_ids, ","); 
			$crit[]="Rlthstgrp.group_id in (".$group_ids.")";
		}
		//$search = $this->Host->findAll($crit);
		
		$asso = array(
			'Rlthstgrp : rlthstgrps' => array('Rlthstgrp.host_id = Host.id '),
			'Group : groups' => array('Group.id = Rlthstgrp.group_id '),
			);

		$flds = array(
			'Host.id',
			'Host.host_name',
			'Group.group_name',
		);

		$search = $this->Host->findByAsso($crit, $flds, 'Host.host_name', null, null, $asso);

			
		$this->set('search', $search);
	}
	
	function _checkAccount($accounts = array(), &$result){
		
		$ad = $this->Activedirectory->find();
		//AD設定が無い
		if(empty($ad)){
			return 2;
		}
		$domain_name  = $ad['Activedirectory']['domain_name'];
		$domain_controller  = $ad['Activedirectory']['dc'];
		$domain_admin  = $ad['Activedirectory']['adminuser'];
		$domain_password  = $ad['Activedirectory']['password'];
		
		//設定ファイル内容
		$contents = "[Config]\r\n";
		$contents .= "Type=WMI";
		$contents .= "\r\n";
		$contents .= "Mode=Account";
		$contents .= "\r\n";
		$contents .= "DomainController=".$domain_controller;
		$contents .= "\r\n";
		$contents .= "UserName=".$domain_admin;
		$contents .= "\r\n";
		$contents .= "PassWord=".$this->Lv->save_decode($domain_password);
		$contents .= "\r\n";

		$contents .= "[Target]\r\n";
		$i=0;
		foreach($accounts as $name){
			$contents .= "Account_".$i++."=".$name;
			$contents .= "\r\n";
		}

		//一時ファイル作成　BEGIN
		$filename = "ad".substr(md5(time().rand(0,1000000)),0,10) . ".ini";
		$csv_folder=ROOT.DS.APP_DIR.DS."tmp".DS."csv".DS;
		$file = $csv_folder.$filename;
		$fp = fopen($file, 'w');  

		$enc= $this->set_str_encoding($contents);
		fputs($fp, $enc);
		
		fclose($fp);
	
		//exe実行
		$v_path=(VENDORS);
		$tmpfname = "LvADCheckTool.exe";
		$wd = getcwd();
		chdir($v_path);
		$output = array();
		$result = exec( sprintf("%s \"%s\"", $tmpfname, $file), $output, $return_var);

		//一時ファイル削除
		unlink($file);
		chdir($wd);
		//var_dump( $output);
		//var_dump( $return_var);
		return $return_var;
	}
	
	
}
?>